<template>
  <div id="app">
    <div id="nav">
      <router-link to="/">Home</router-link> |
      <router-link to="/about">About</router-link>
    </div>

    <VButton v-if="form.value" href="https://google.com">Link</VButton>
    <VButton :to="{ name: 'About' }">ROuter link</VButton>
    <VButton type="button" @click="submitForm">Button</VButton>
    <VControl
      v-model="form.controls.name.value"
      :control="form.controls.name"
      label="label1"
    />
    <VControl
      v-model="form.controls.surname.value"
      :control="form.controls.surname"
      label="label2"
    />
    <router-view />
  </div>
</template>
<script>
import VButton from "@/components/VButton";
import { ReactiveForm } from "@/ReactiveForm/ReactiveForm.ts";
import { ReactiveFormControl } from "@/ReactiveForm/ReactiveFormControl.ts";
import { Validators } from "@/ReactiveForm/Validators.ts";
import VControl from "@/components/VControl";

export default {
  components: { VControl, VButton },
  data: () => ({
    testik: "",
    form: new ReactiveForm()
  }),
  created() {
    this.form.createForm({
      name: new ReactiveFormControl("", [
        Validators.required,
        Validators.stringLength(3, 128)
      ]),
      surname: new ReactiveFormControl("", [
        Validators.required,
        Validators.stringLength(3, 10)
      ])
    });
  },
  methods: {
    submitForm() {
      this.form.submit();
      if (this.form.hasErrors) return console.log("error");
      console.log("success");
      console.log(this.form);
    }
  }
};
</script>
